<?
int p = N("04_multitasking:timer0:prescaler"); // N("04_multitasking:prescaler");
int bits = N("04_multitasking:timer0:bits")==16 ? 65535 : 255;
int ll = N("04_multitasking:timer0:ticks:"+p*(bits-(N("04_multitasking:priolowlow")-1)));
int l = N("04_multitasking:timer0:ticks:"+p*(bits-(N("04_multitasking:priolow")-1)));
int m = N("04_multitasking:timer0:ticks:"+p*(bits-(N("04_multitasking:priomedium")-1)));
int h = N("04_multitasking:timer0:ticks:"+p*(bits-(N("04_multitasking:priohigh")-1)));
int hh = N("04_multitasking:timer0:ticks:"+p*(bits-(N("04_multitasking:priohighhigh")-1)));
string llt = S("04_multitasking:timer0:time:ticks="+p*(bits-(N("04_multitasking:priolowlow")-1)));
string lt = S("04_multitasking:timer0:time:ticks="+p*(bits-(N("04_multitasking:priolow")-1)));
string mt = S("04_multitasking:timer0:time:ticks="+p*(bits-(N("04_multitasking:priomedium")-1)));
string ht = S("04_multitasking:timer0:time:ticks="+p*(bits-(N("04_multitasking:priohigh")-1)));
string hht = S("04_multitasking:timer0:time:ticks="+p*(bits-(N("04_multitasking:priohighhigh")-1)));
string pmint = S("04_multitasking:timer0:time:ticks="+p*(bits-(bits-1)));
string pmaxt = S("04_multitasking:timer0:time:ticks="+p*(bits-(0-1)));

if (p < 1) P("// WARNING: timer disabled\r\n");
?>#ifndef _multitasking_h_
#define _multitasking_h_

#include <avr/io.h>
#include <avr/interrupt.h>

#define sleep() asm volatile ("sleep")

#define STACK_SIZE	<?$04_multitasking:stacksize?><?
if (N("04_multitasking:stacksize") < 32) P(" // WARNING: stacksize to small");?>
#define NUM_TASKS	<?$04_multitasking:numtasks?>

typedef void (*TaskFunction)();

// the lower the prio is (0..<?P(bits);?>) the more time gets a task to run
// 0 = max prio (= <?P(pmaxt);?>)
// <?P(bits);?> = min prio (= <?P(pmint);?>)
// times & cycles at <?$cpu:mhz?>MHz and CLK/<?$04_multitasking:prescaler?>:
typedef enum TaskPrio
{
	TaskPrioLowLow		= <?$04_multitasking:priolowlow?>,	// <?P(ll);?> ticks (= <?P(llt);?>)
	TaskPrioLow			= <?$04_multitasking:priolow?>,	// <?P(l);?> ticks (= <?P(lt);?>)
	TaskPrioMedium		= <?$04_multitasking:priomedium?>,	// <?P(m);?> ticks (= <?P(mt);?>)
	TaskPrioHigh		= <?$04_multitasking:priohigh?>,	// <?P(h);?> ticks (= <?P(ht);?>)
	TaskPrioHighHigh	= <?$04_multitasking:priohighhigh?>	// <?P(hh);?> ticks (= <?P(hht);?>)
} TaskPrio;

typedef volatile struct Task
{
	volatile unsigned char sreg; // task sreg
	volatile unsigned char *sp; // task stack pointer
	volatile TaskPrio prio;
	volatile unsigned char stack[STACK_SIZE]; // the task stack is embedded in this structure
} Task;

// create task & add to task-list
void taskCreate(Task *t, TaskFunction f, TaskPrio prio);

// trigger a task switch
// if called from the main thread it starts the scheduler
void taskSwitch();

static volatile unsigned char currentTask = 255;
static volatile Task *tasks[NUM_TASKS];

#endif
<?show();P("\r\n\r\n// generated by AvrWiz on "+System.DateTime.Now);?>