<?
int timerNum     = (int)N("01_timer:timer");
string timerName = "Timer"+S("01_timer:timer");
int ticks        = (int)N("01_timer:timer0:ticks");
int realticks    = (int)N("01_timer:timer0:realticks");
string timerErr  = S("01_timer:timer0:err");

double s1 = Convert.ToDouble(S("01_timer:timer0:sec"));
double s2 = Convert.ToDouble(S("01_timer:timer0:realsec"));
string sepd = "" + ((s1 * 60 * 60 * 24) - (s2 * 60 * 60 * 24));
if (sepd.Length > 6) sepd = sepd.Substring(0, 6);
?>// -------------
// --- timer ---
// -------------

#include <avr/io.h>
//#include <avr/interrupt.h>

// the values are calculated with AvrWiz for <?$cpu:cpu?> @ <?$cpu:mhz?> mhz
// <?P(timerName);?> settings: <?$01_timer:timer0:ticks?> ticks (= <?$01_timer:timer0:time?>)
<?if (ticks != realticks) P("// !!! warning !!! real ticks = "+realticks+" (= "+S("01_timer:timer0:realtime")+"), err = "+timerErr+"% !!!\r\n// (seconds error per day = "+sepd+")\r\n");
?><?if (B("01_timer:interrupts") || N("01_timer:timer0:prescaler") > 0) show(); else hide();?>
// <?P(timerName);?> Overflow
ISR(<?$01_timer:timer0:irq_ovf?>_vect)
{
	// reinit counter
<?if (S("01_timer:timer0:cpu_counterh").Length > 0) P("\t"+S("01_timer:timer0:cpu_counterh")+" = "+S("01_timer:timer0:v_counterh")+";\r\n");?>	<?$01_timer:timer0:cpu_counterl?> = <?$01_timer:timer0:v_counterl?>;
}
<?if (B("01_timer:interrupts") && S("01_timer:timer0:irq_capt").Length>0) show(); else hide();?>
// <?P(timerName);?> Capture
ISR(<?$01_timer:timer0:irq_capt?>_vect)
{
}
<?if (B("01_timer:interrupts") && S("01_timer:timer0:irq_compa").Length>0) show(); else hide();?>
// <?P(timerName);?> Compare A
ISR(<?$01_timer:timer0:irq_compa?>_vect)
{
}
<?if (B("01_timer:interrupts") && S("01_timer:timer0:irq_compb").Length>0) show(); else hide();?>
// <?P(timerName);?> Compare B
ISR(<?$01_timer:timer0:irq_compb?>_vect)
{
}
<?if (B("01_timer:interrupts") && S("01_timer:timer0:irq_compc").Length>0) show(); else hide();?>
// <?P(timerName);?> Compare C
ISR(<?$01_timer:timer0:irq_compc?>_vect)
{
}
<?show();?>
void <?P(timerName);?>_init()
{
	// <?P(timerName);?> settings: ~ <?$01_timer:timer0:realticks?> ticks (<?$01_timer:timer0:realtime?>)
	<?$01_timer:timer0:cpu_control?> = <?$01_timer:timer0:v_control?>; // prescaler = <?$01_timer:timer0:prescaler?>
	// init counter
<?if (S("01_timer:timer0:cpu_counterh").Length > 0) P("\t"+S("01_timer:timer0:cpu_counterh")+" = "+S("01_timer:timer0:v_counterh")+";\r\n");?>	<?$01_timer:timer0:cpu_counterl?> = <?$01_timer:timer0:v_counterl?>;
<?if (B("01_timer:interrupts") || N("01_timer:timer0:prescaler") > 0) show(); else hide();?>	<?$01_timer:timer0:cpu_enable?> = <?P(S("01_timer:timer0:v_enable"+(B("01_timer:interrupts")?":interrupts":"")));?>; // <?P(timerName);?> Overflow Interrupt Enable
<?if (B("01_timer:interrupts") && S("01_timer:timer0:irq_capt").Length>0) show(); else hide();?>//TODO: enable irq: capt
<?if (B("01_timer:interrupts") && S("01_timer:timer0:irq_compa").Length>0) show(); else hide();?>//TODO: enable irq: compa
<?if (B("01_timer:interrupts") && S("01_timer:timer0:irq_compb").Length>0) show(); else hide();?>//TODO: enable irq: compb
<?if (B("01_timer:interrupts") && S("01_timer:timer0:irq_compc").Length>0) show(); else hide();?>//TODO: enable irq: compc
<?show();?>}

void init_timer()
{
	<?P(timerName);?>_init();
}

<?show();P("\r\n\r\n// generated by AvrWiz on "+System.DateTime.Now);?>
<?if (B("01_timer:help")) show(); else hide();?>
/*
TimerControl properties:
	num = <?$01_timer:timer0:num?>
	bits = <?$01_timer:timer0:bits?>
	time = <?$01_timer:timer0:time?>
	realtime = <?$01_timer:timer0:realtime?>
	min = <?$01_timer:timer0:min?>
	max = <?$01_timer:timer0:max?>
	ticks = <?$01_timer:timer0:ticks?>
	realticks = <?$01_timer:timer0:realticks?>
	err = <?$01_timer:timer0:err?>
	us = <?$01_timer:timer0:us?>
	ms = <?$01_timer:timer0:ms?>
	sec = <?$01_timer:timer0:sec?>
	unit = <?$01_timer:timer0:unit?>
	prescaler = <?$01_timer:timer0:prescaler?>
	counter = <?$01_timer:timer0:counter?>
	irq_ovf = <?$01_timer:timer0:irq_ovf?>
	irq_capt = <?$01_timer:timer0:irq_capt?>
	irq_compa = <?$01_timer:timer0:irq_compa?>
	irq_compb = <?$01_timer:timer0:irq_compb?>
	irq_compc = <?$01_timer:timer0:irq_compc?>
	cpu_control = <?$01_timer:timer0:cpu_control?>
	cpu_counter = <?$01_timer:timer0:cpu_counter?>
	cpu_counterh = <?$01_timer:timer0:cpu_counterh?>
	cpu_counterl = <?$01_timer:timer0:cpu_counterl?>
	cpu_enable = <?$01_timer:timer0:cpu_enable?>
*/
<?show();?>